Problem statement

A message containing letters from A-Z can be encoded into numbers using the following mapping:

'A' -> "1"
'B' -> "2"
...
'Z' -> "26"

To decode an encoded message, all the digits must be grouped then mapped back into letters using the reverse of the mapping above (there may be multiple ways). For example, “11106” can be mapped into:

“AAJF” with the grouping (1 1 10 6) “KJF” with the grouping (11 10 6) Note that the grouping (1 11 06) is invalid because “06” cannot be mapped into ‘F’ since “6” is different from “06”.

Given a string s containing only digits, return the number of ways to decode it.

The test cases are generated so that the answer fits in a 32-bit integer.

Link to problem

Example 1

Input: s = "12"
Output: 2
Explanation: "12" could be decoded as "AB" (1 2) or "L" (12).

Example 2

Input: s = "226"
Output: 3
Explanation: "226" could be decoded as "BZ" (2 26), "VF" (22 6), or "BBF" (2 2 6).

Solutions

Approach 1: Dynamic Programming

If you’ve done a few DP problems, they all appear to follow the exact same pattern, add the previous count to the current count and return the last element in the resultant list.

This problem is no different, you initialize a list of counts and count based on the edge cases, in this case the two edge cases are:

  1. Getting a value above 26
  2. Value containing 0 or starting with zero

Implementation in Python

def numDecodings(self, s: str) -> int:
    if not s or s[0] == "0":
        return 0
    
    # Generally len(s) ways but edge cases are if we get more than 26
    result = [0 for i in range(len(s) + 1)]
    result[0] = 1 # extra
    result[1] = 1 # 1 way to count 1 item
    
    for i in range(2, len(s) + 1):
        # one character
        if int(s[i-1:i]) > 0:
            result[i] += result[i-1]
        
        # two characters
        if int(s[i-2:i]) >= 10 and int(s[i-2:i]) <= 26:
            result[i] += result[i-2]
    return result[-1]

Time Complexity: $O(n)$
Runtime on LeetCode: $45$ms